package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.diagbot.entity.QuestionUsual;
import com.diagbot.entity.wrapper.QuestionUsualWapper;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.enums.UsualEnum;
import com.diagbot.exception.CommonErrorCode;
import com.diagbot.exception.CommonException;
import com.diagbot.service.QuestionUsualService;
import com.diagbot.service.impl.QuestionUsualServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.DateUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.vo.DeleteQuestionUsualVO;
import com.diagbot.vo.QuestionUsualVO;
import com.google.common.collect.Lists;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Description:
 * @author: wangyu
 * @time: 2018/12/3 17:06
 */
@Component
public class QuestionUsualFacade extends QuestionUsualServiceImpl {
    @Autowired
    private QuestionInfoFacade questionInfoFacade ;
    @Autowired
    private DeptInfoFacade deptInfoFacade;
    @Autowired
    @Qualifier("questionUsualServiceImpl")
    private QuestionUsualService questionUsualService;

    /**
     * 添加常用标签
     * @param questionUsualVO
     * @return
     */
    public Boolean addQuestionUsual(QuestionUsualVO questionUsualVO) {
        List<QuestionUsual> addList = Lists.newArrayList();
        //判断该科室是否添加过常用标签
        QuestionUsual questionUsual = new QuestionUsual();
        String userId = "1"/*UserUtils.getCurrentPrincipleID()*/;
        QuestionUsualWapper questionUsualWapper = new QuestionUsualWapper();
        List<QuestionUsual> questionUsualList = this.getQuestionUsualByQuestionId(questionUsualVO);
        if(ListUtil.isNotEmpty(questionUsualList)){
            questionUsual = new QuestionUsual();
            BeanUtil.copyProperties(questionUsualVO,questionUsualWapper);
            questionUsualWapper.setModifier(userId);
            questionUsualWapper.setGmtModified(DateUtil.now());
            this.updateQuestionUsualByQuestionId(questionUsualWapper);
        }
        for (int i = 0; i<questionUsualVO.getQuestionId().size(); i++ ) {
            questionUsual = new QuestionUsual();
            questionUsual.setCreator(userId);
            questionUsual.setModifier(userId);
            questionUsual.setGmtCreate(DateUtil.now());
            questionUsual.setGmtModified(DateUtil.now());
            questionUsual.setQuestionId(questionUsualVO.getQuestionId().get(i));
            questionUsual.setDeptId(questionUsualVO.getDeptId());
            questionUsual.setOrderNo(Long.parseLong(String.valueOf(i+1)));
            questionUsual.setUsual(String.valueOf(UsualEnum.Enable.getKey()));
            addList.add(questionUsual);
        }
        Boolean flag = questionUsualService.saveBatch(addList);
        if(!flag){
            throw new CommonException(CommonErrorCode.INSERT_DATA_FAILED,
                    "常用症状添加失败");
        }
        return true;
    }

    /**
     * 删除常用标签
     * @param deleteQuestionUsualVO
     * @return
     */
    public Boolean deleteQuestionUsualByDeptId(DeleteQuestionUsualVO deleteQuestionUsualVO){
        String userId = "1"/*UserUtils.getCurrentPrincipleID()*/;
        UpdateWrapper<QuestionUsual> queryWrapper = new UpdateWrapper<>();
        queryWrapper.eq("dept_id",deleteQuestionUsualVO.getDeptId()).set("is_deleted", IsDeleteEnum.Y.getKey())
                .set("modifier", userId)
                .set("gmt_modified", DateUtil.now());
        this.update(new QuestionUsual(),queryWrapper);
        return true;
    }
}
