package com.diagbot.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.diagbot.dto.GetQuestionInfoDTO;
import com.diagbot.dto.QuestionPageDTO;
import com.diagbot.entity.QuestionInfo;
import com.diagbot.vo.GetQuestionInfoVO;
import com.diagbot.vo.GetQuestionUsualByDeptVO;
import com.diagbot.vo.QuestionPageVO;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 标签基础表 服务类
 * </p>
 *
 * @author zhaops
 * @since 2018-11-23
 */
public interface QuestionInfoService extends IService<QuestionInfo> {



    /**
     * 根据id删除标签
     *
     * @param map
     * @return
     */
    public void deleteByIds(Map map);

    /**
     * 根据名称获取标签信息
     *
     * @param getQuestionInfoVO
     * @return
     */
    public List<GetQuestionInfoDTO> getQuestiongInfoByName(GetQuestionInfoVO getQuestionInfoVO);

    /**
     * 检索
     *
     * @param map
     * @return
     */
    public List<QuestionInfo> index(Map map);


    /**
     * 获取标签列表
     *
     * @param questionPageVO
     * @return
     */
    IPage<QuestionPageDTO> getList(QuestionPageVO questionPageVO);

    /**
     * 根据科室id获取标签信息
     * @param getQuestionUsualByDeptVO
     * @return
     */
    public List<GetQuestionInfoDTO> getQuestionUsualsByDept(GetQuestionUsualByDeptVO getQuestionUsualByDeptVO);
}


