package com.diagbot.web;

import com.diagbot.dto.RespDTO;
import com.diagbot.facade.UploadFacade;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.util.HashMap;
import java.util.Map;

@RestController
@Api(value = "文件上传API", tags = { "文件上传API" })
@RequestMapping(value = "/file",method = RequestMethod.GET)
@SuppressWarnings("unchecked")
public class UploadController {
    @Autowired
    private UploadFacade uploadFacade;

    @PostMapping("/uploadImage")
    public RespDTO<Map<String, Object>> singleFileUpload(@RequestParam("upfile") MultipartFile file) {
        return RespDTO.onSuc(uploadFacade.singleFileUpload(file));
    }


    @PostMapping("/deleteRemoteFile")
    public RespDTO<Boolean> deleteRemoteFile(@RequestParam("path") String path) {
        return RespDTO.onSuc(uploadFacade.deleteRemoteFile(path));
    }
}